(defun set-x68-crtmod-18()
  (interactive)
  (if (eq window-system 'sx)
      nil
    (set-x68-crtmod 18)
    (set-x68-screen-height 848)
    (set-x68-screen-width 1024)))
(defun set-x68-crtmod-16()
  (interactive)
  (if (eq window-system 'sx)
      nil
    (set-x68-crtmod 16)
    (set-x68-screen-height 512)
    (set-x68-screen-width 768)))
(defun set-x68-crtmod-1()
  (interactive)
  (if (eq window-system 'sx)
      nil
    (set-x68-crtmod 1)
    (set-x68-background-color 0)
    (set-x68-foreground-color
     (rgbi-to-colorcode 0 31 10 1))
    (set-x68-top-margin 26)
    (set-x68-left-margin 30)
    (set-x68-screen-height 480)
    (set-x68-screen-width 500)))
(defun rgbi-to-colorcode(r g b i)
  (+ i (* 2 (+ b (* 32 (+ r (* 32 g)))))))
(defun colorcode-to-rgbi (x)
  (list 
   (mod (/ x 32 2) 32)
   (/ x 32 32 2)
   (mod (/ x 2) 32)
   (mod x 2)))
(defvar user-real-name (cond
			((getenv "REALNAME"))
			(t "unknown"))
  "this variable is used for function insert-name-and-current-time-as-comment
default-value is defined by environment variable REALNAME")
(defun insert-email-address ()
  (interactive)
  (insert (getenv "USER"))
  (insert "@")
  (insert gnus-use-generic-from))

(defun kill-word-wordstarlike()
  "kill word like wordstar"
  (interactive)
  (if (not (looking-at "[ \t\n]"))
      (delete-region (point) (progn (forward-word 1) (point))))
  (delete-region (point) (progn (skip-chars-forward " \t") (point))))
(global-set-key "\C-t" 'kill-word-wordstarlike)

(defun current-date-string ()
  "return current date string like 93.10.15"
  (let* ((time (current-time-string))
	 (junk (string-match "[A-Z][a-z][a-z] *\\([A-Z][a-z][a-z]\\) *\\([0-9]*\\)" time)))
    (concat
     (substring time (- (length time) 2))
     "."
     (cdr (assoc
	   (substring time (match-beginning 1) (match-end 1))
	   '(("Jan" . 1) ("Feb" . 2) ("Mar" . 3) ("Apr" . 4) ("May" . 5) ("Jun" . 6)
	     ("Jul" . 7) ("Aug" . 8) ("Sep" . 9) ("Oct" . 10) ("Nov" . 11) ("Dec" . 12))))
     "."
    (substring time (match-beginning 2) (match-end 2)))))

(defun insert-name-and-current-time-as-comment()
  "insert current date and variable user-real-name
like /* 93.10.21 by (user-real-name) */		(C mode)
     ; 93.10.21 by (user-real-name)		(lisp mode)"
  (interactive)
  (indent-for-comment)
  (insert-string
   (current-date-string)
   " by "
   user-real-name))
(setq esc-sequence-regexp "[[0-9]*;*[0-9]*[A-Z,a-z]")
(defun delete-esc-sequence()
  "delete regexp esc-sequence-regexp(v)
default value of esc-sequence-regexp is [[0-9]*;*[0-9]*[A-Z,a-z]"
  (interactive)
  (replace-regexp esc-sequence-regexp ""))

(defun delete-ish ()
  (interactive)
  (re-search-forward "^<<< .*(.*) \\[ *\\([0-9]*\\) lines \\].*>>>")
  (let* ((head (buffer-substring (match-beginning 0) (match-end 0)))
	 (line
	  (string-to-int (buffer-substring (match-beginning 1) (match-end 1))))
	 (ishstart (progn
		     (beginning-of-line)
		     (point)))
	 (junk (substring head 4))
	 (name (substring junk 0 (string-match " " junk))))
    (forward-line (1- line))
    (if (= (point) (point-max))
	(setq junk "junk.xx.xx.xx. junk")
	(setq junk (buffer-substring (+ 4 (point)) (+ 30 (point)))))
    (cond ((string-equal name (substring junk 0 (string-match " " junk)))
	   (forward-line 1)
	   (delete-region ishstart (point)))
	  (t (goto-char ishstart)))))

(defun cr-to-lf()
  "replace CR to LF"
  (interactive)
  (replace-string "\C-M" "\C-J"))
(defun auto-fill-text-mode ()
  (interactive)
  (text-mode)
  (auto-fill-mode 1))

(defun attribute-inverse-region() (interactive) 
  (attribute-on-region 'inverse (mark) (point)))

(defun attribute-bold-region() (interactive) 
  (attribute-on-region 'bold (mark) (point)))

(defun attribute-underline-region() (interactive) 
  (attribute-on-region 'underline (mark) (point)))
