;; SXWINDOW $B$G(B SXBASIC $B7?<0$N%?%9%/4VDL?.$r;H$C$F!"(Bshell.el $B$d(B
;; inferior-lisp-mode $B$rAv$i$9$3$H$rL\E*$K$7$^$9!#(B

;; $B$H$j$"$($:$O!"(Binferior-lisp-mode $B$N$_$N8BDjE*$J%5%]!<%H!#(B
;; $B$=$N$?$a!"?'!9$J0UL#$G!":GDc$J%W%m%0%i%`!#(B
;; $BK\Ev$O!"(BC $B%W%m%0%i%`$r$$$8$/$i$J$1$l$P$J$i$J$$$N$K!"(B
;; $BLLE]$@$+$i$d$C$F$J$$!#(B

;; GNU Emacs is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 1, or (at your option)
;; any later version.

;; GNU Emacs is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

;; 94.6.06 by T.Ishikura Mule Ver.1.1 on sxwindow by T.Ishikura

(require 'shell)

(defvar *lisp*process-marker)
(defvar *lisp*taskid -1)

(defun process-mark (proc)
  (if (string= proc "lisp")
      *lisp*process-marker))

(defun get-buffer-process (buffer)
  (if (string= (buffer-name buffer) "*lisp*")
      "lisp"))

(defun get-process (process)
  (if (string= process "lisp")
      "lisp"))

(defun process-id (process)
  (if (string= process "lisp")
      *lisp*taskid))

(defun run-lisp ()
  "Run an inferior Lisp process, input and output via buffer *lisp*."
  (interactive)
  (switch-to-buffer "*lisp*")
  (setq *lisp*taskid (sx-tsfock "QuTerm.x"))
  (setq *lisp*process-marker (point-max-marker))
  (inferior-lisp-mode))

(defun process-send-region (process start end)
  (if (string= process "lisp")
      (process-send-string "lisp" (buffer-substring start end))))

(defun process-get ()
  (if (not (= (car(car sx-sxbasic-message-list))
	 *lisp*taskid))
      (sx-sxbasic-message-default)
    (let ((cbuffer (current-buffer)))
      (set-buffer (marker-buffer *lisp*process-marker))
      (push-mark (marker-position *lisp*process-marker))
      (insert-before-markers
       (code-convert-string
	(car (cdr (car sx-sxbasic-message-list)))
	*sjis*dos *internal*))
      (pop-mark)
      (set-buffer cbuffer))
    (setq sx-sxbasic-message-list (cdr sx-sxbasic-message-list))))

(setq sx-sxbasic-message-hooks 'process-get)


(defun process-send-string (name s)
  (if (sx-send-sxbasic-message s (process-id name))
      nil
    (error "Can't send sxbasic message")))

