/* 94.4.09 by T.Ishikura */
/* this is file in the Public Domain */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *input;
FILE *output;

int main(int argc, char *argv[])
{
  int outno;
  int unit;
  
  if (argc < 3)
    {
      fprintf (stderr,"\nUSAGE: bsplit0 splitfile size outputbasename.\n");
      exit (-1);
    }
  
  if (!(input = fopen (argv[1], "rb")))
    {
      fprintf (stderr,"Can't open file %s\n.", argv[1]);
      exit (-1);
    }
  
  if ((unit = atoi (argv[2])) <= 100)
    {
      fprintf (stderr,"number error %s\n.", argv[2]);
      exit (-1);
    }

  for (outno = 0 ; outno < 1000 ; outno++)
    {
      char namebuf[256];
      int namelen;
      static char buf[65536];
      int h,k,l;
      int rest;

      strcpy (namebuf,argv[3]);
      namelen = strlen (argv[3]);
      namebuf[namelen++] = (outno / 100) + '0';
      namebuf[namelen++] = ((outno / 10 ) % 10) + '0';
      namebuf[namelen++] = (outno % 10) + '0';
      namebuf[namelen] = 0;
      if (!(output = fopen (namebuf, "wb")))
	{
	  fprintf (stderr,"Can't open file %s.\n", namebuf);
	  exit (-1);
	}
      rest = unit;
      while (rest != 0)
	{
	  if (rest >= 65536)
	    {
	      l = 65536;
	      rest -= 65536;
	    }
	  else
	    {
	      l = rest;
	      rest = 0;
	    }
	  h = fread (buf, 1, l, input);
	  k = fwrite (buf, 1, h, output);
	  if (h != k)
	    {
	      fprintf(stderr,"write error. \n");
	      exit (-1);
	    }
	  if (h != l)
	      rest = 0;
	}
      fclose (output);
      if (h != l)
	break;
    }
  return 0;
}
