;; delete document string from bytecompiled files for Mule on X68000

;; You can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 1, or (at your option)
;; any later version.

;; created 93.11.22 by T.Ishikura

(defun delete-bytecode-comment ()
  (while (search-forward "\"\\\n" nil t)
    (setq i (point))
    (backward-char 3)
    (forward-sexp 1)
    (backward-char 1)
    (delete-region i (point))))

(defun delete-bytecode-comment-files (flist)
  (mapcar
   '(lambda (file)
      (find-file file *noconv*)
      (goto-char (point-min))
      (delete-matching-lines "^;;;")
      (goto-char (point-min))
      (delete-bytecode-comment)
      (save-buffer)
      (kill-buffer file))
   flist))

(cd (getenv "EMACSLOADPATH"))

(delete-bytecode-comment-files '("subr.elc" "mule.elc" "simple.elc" "help.elc" "files.elc"
				 "indent.elc" "window.elc" "startup.elc" "lisp.elc"
				 "page.elc" "register.elc" "paragraphs.elc" "lisp-mode.elc"
				 "text-mode.elc" "fill.elc" "isearch.elc" "replace.elc"
				 "abbrev.elc" "buff-menu.elc" "keyboard.elc" "mule-util.elc"
				 "site-init.elc" "japanese.elc" "saveconf.elc" "c-mode.elc"
				 "worddef.elc" "sxwindow.elc"))

(shell-command (concat "touch "
		       "subr.el " "mule.el " "simple.el " "help.el " "files.el "
				 "indent.el " "window.el " "startup.el " "lisp.el "
				 "page.el " "register.el " "paragraphs.el " "lisp-mode.el "
				 "text-mode.el " "fill.el " "isearch.el " "replace.el "
				 "abbrev.el " "buff-menu.el " "keyboard.el " "mule-util.el "
				 "site-init.el " "japanese.el " "saveconf.el " "c-mode.el "
				 "worddef.el " "sxwindow.el "))

